/*
 * VirtualPC state file "vsv" Viewer
 *  for analysis
 *  by Murachue
 *  for INT32 environment.
 */

#include <stdio.h>

struct entry{
	int nameofs;
	int unk;
	int namelen;
	int dataofs;
	int datalen;
	int datalen2;
	int resv1;
	int resv2;
};

int main(int argc, char* argv[])
{
	FILE* fp;
	char tmp[256];
	int count;

	char* fname;
	int listmode = 0;

	long oldp;
	struct entry e;
	int i, j;

	if(argc < 2)
	{
		printf("vsview: build: %s %s\n", __DATE__, __TIME__);
		printf(" please specify filename.\n");
		return 1;
	}

	printf("*** Welcome to VSVIEW ***\n");

	for(i = 1; i < argc; i++)
	{
		if(argv[i][0] == '-')
			for(j = 1; argv[i][j]; j++)
				switch(argv[i][j])
				{
					case 'l':
						printf(">>Listmode\n");
						listmode = 1;
						break;
				}
		else
			fname = argv[i];
	}

	if((fp = fopen(fname, "rb")) == NULL)
	{
		printf("vsview: Can't open file %s\n", fname);
		return 1;
	}

	fread(tmp, sizeof(int), 1, fp);
	if(*(int *)tmp != 0x13579BDF)
	{
		printf("vsview: Incorrect sigunature\n");
		return 1;
	}

	fread(tmp, sizeof(int), 1, fp);
	if(*(int *)tmp != 0x00020000)
	{
		printf("vsview: may be version incorrect\n");
		return 1;
	}

	fread(tmp, sizeof(int), 1, fp);
	fseek(fp, (long)*(int *)tmp, SEEK_SET);

	printf("Seeking completed.\n");

	for(count = 0; ; count++)
	{

		fread(&e, sizeof(struct entry), 1, fp);
		if(e.nameofs == 0)	// EntryEnd
			break;
		if(listmode == 0)
		{
			printf("COUNT: %d\n", count);
			printf("Offset: %08X\n", e.nameofs);
			printf("[unknown]: %08X\n", e.unk);
			printf("strlen: %08X\n", e.namelen);
			printf("dataptr: %08X\n", e.dataofs);
			printf("datalen: %08X\n", e.datalen);
			if(e.datalen != e.datalen2)
				printf("datalen2: %08X\n", e.datalen2);
			if(e.resv1 != 0)
				printf("0: %08X\n", e.resv1);
			if(e.resv2 != 0)
				printf("0: %08X\n", e.resv2);
		}
		oldp = ftell(fp);

		fseek(fp, e.nameofs, SEEK_SET);
		fread(tmp, sizeof(char), e.namelen, fp);
		tmp[e.namelen] = '\0';
		if(listmode == 0)
			printf("NAME: ");
		printf("%s\n", tmp);
		if(listmode == 0)
		{
			printf("dump:\n");
			fseek(fp, e.dataofs, SEEK_SET);
			for(i = 0; i < e.datalen; i += 0x10)
			{
				int max = ((e.datalen - i) > 16) ? 16 : (e.datalen - i);
				printf("%08X+%08X: ", e.dataofs, i);
				fread(tmp, sizeof(char), max, fp);
				for(j = 0; j < max; j++)
					printf("%02X ", *(tmp + j) & 0xFF);
				for(j = 16; j > max; j--)
					printf("   ");
				printf("| ");
				for(j = 0; j < max; j++)
					if(*(tmp + j) < 0x20 || *(tmp + j) == 0x7F)
						printf(".");
					else
						printf("%c", *(tmp + j));
				printf("\n");
			}
		}

		fseek(fp, oldp, SEEK_SET);
		if(listmode == 0)
			printf("\n");
	}

	fclose(fp);

	return 0;
}
